<!-- HTML header for doxygen 1.8.8-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <!-- For Mobile Devices -->
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
        <meta name="generator" content="Doxygen 1.8.14"/>
        <script type="text/javascript" src="https://code.jquery.com/jquery-2.1.1.min.js"></script>
        <title>libinput: Reporting bugs</title>
        <!--<link href="tabs.css" rel="stylesheet" type="text/css"/>-->
        <script type="text/javascript" src="dynsections.js"></script>
        <script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" async src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
        <link href="doxygen.css" rel="stylesheet" type="text/css" />
        <link href="bootstrap.css" rel="stylesheet" type="text/css"/>
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
<link href="libinputdoxygen.css" rel="stylesheet" type="text/css"/>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.1/js/bootstrap.min.js"></script>
        <script type="text/javascript" src="doxy-boot.js"></script>
    </head>
    <body>
        <nav class="navbar navbar-default" role="navigation">
            <div class="container">
                <div class="navbar-header">
                    <a class="navbar-brand">libinput 1.11.1</a>
                </div>
            </div>
        </nav>
        <div id="top"><!-- do not remove this div, it is closed by doxygen! -->
            <div class="content" id="content">
                <div class="container">
                    <div class="row">
                        <div class="col-sm-12 panel panel-default" style="padding-bottom: 15px;">
                            <div style="margin-bottom: 15px;">
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="misc.html">Users</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Reporting bugs </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><br />
</p>
<p>A new bug can be filed here: <a href="https://gitlab.freedesktop.org/libinput/libinput">https://gitlab.freedesktop.org/libinput/libinput</a></p>
<p>When reporting bugs against libinput, please follow the instructions below and provide the required data. You will need:</p>
<ul>
<li>a reliable <a class="el" href="reporting_bugs.html#reporting_bugs_reproducer">reproducer</a> for the bug</li>
<li>an <a class="el" href="reporting_bugs.html#evemu">evemu recording</a> of the device while the bug is reproduced</li>
<li>device-specific information, see<ul>
<li><a class="el" href="reporting_bugs.html#reporting_bugs_touchpad">Reporting touchpad bugs</a></li>
<li><a class="el" href="reporting_bugs.html#reporting_bugs_mouse">Reporting mouse bugs</a></li>
<li><a class="el" href="reporting_bugs.html#reporting_bugs_keyboard">Reporting keyboard bugs</a></li>
<li><a class="el" href="reporting_bugs.html#reporting_bugs_trackpoint">Reporting trackpoint bugs</a></li>
<li><a class="el" href="reporting_bugs.html#reporting_bugs_other">All other devices</a></li>
</ul>
</li>
<li>the <a class="el" href="reporting_bugs.html#reporting_bugs_version">libinput version</a> you are on.</li>
<li>the <a class="el" href="reporting_bugs.html#reporting_bugs_options">configuration options</a> you have set</li>
<li>a bugzilla account</li>
</ul>
<p>If you don't have all of the above, provide a reason why not. Unless the reason is justified, the bug will have low priority. Remember, libinput has a lot of users but very few developers.</p>
<p>Stay technical, on-topic, and keep the description concise.</p>
<h1><a class="anchor" id="reporting_bugs_version"></a>
Obtaining the libinput version</h1>
<p>If your libinput version is older than the current stable branch, you will get asked to try the latest version.</p>
<p>If you run a distribution-provided libinput, use the package manager to get the <b>full</b> package name and version of libinput, e.g.</p><ul>
<li><code>rpm -q libinput</code></li>
<li><code>dpkg -s libinput10</code></li>
</ul>
<p>If you run a self-compiled version of libinput provide the git commit you have built or the tarball name.</p>
<p>As a last resort, use <code>libinput-list-devices --version</code></p>
<h1><a class="anchor" id="reporting_bugs_reproducer"></a>
Reproducing bugs</h1>
<p>Try to identify the bug by reproducing it reliably. Bugs without a reliable reproducer will have lowest priority. The more specific a bug description and reproducer is, the easier it is to fix.</p>
<p>Try to replicate the series of events that lead to the bug being triggered. Narrow it down until you have a reliable sequence that can trigger the bug. For the vast majority of bugs you should not take longer than 5 seconds or three interactions (clicks, touches, taps, ...) with the device to reproduce. If it takes longer than that, you can narrow it down further.</p>
<p>Once you can reproduce it, use the <a class="el" href="tools.html#libinput-debug-events">libinput debug-events</a> helper tool. The output is textual and can help identify whether the bug is in libinput at all. Note that any configuration options you have set must be specified on the commandline, see the <a class="el" href="tools.html#libinput-debug-events">libinput-debug-events</a> man page. Use the <code>--verbose</code> flag to get more information about how libinput processes events.</p>
<p>If the bug cannot be reproduced with the <a class="el" href="tools.html#libinput-debug-events">libinput debug-events</a> helper, even with the correct configuration options set, it is likely not a bug in libinput.</p>
<h1><a class="anchor" id="reporting_bugs_options"></a>
libinput configuration settings</h1>
<p>libinput has a number of device-specific default configuration settings that may differ from the ones your desktop environment picks by default. You may have changed some options in a settings panel or in an the xorg.conf snippet yourself.</p>
<p>You must provide these options in the bug report, otherwise a developer reproducing the issue may not be able to do so.</p>
<p>If you are on X11, the current settings can be can be obtained with <code>xinput list-props "your device name"</code>. Use <code>xinput list</code> to obtain the device name.</p>
<p>If you are on Wayland, provide a manual summary of the options you have changed from the default (e.g. "I enabled tap-to-click").</p>
<h1><a class="anchor" id="reporting_bugs_touchpad"></a>
Reporting touchpad bugs</h1>
<p>When you file a bug, please attach the following information:</p>
<ul>
<li>a virtual description of your input device, see <a class="el" href="reporting_bugs.html#evemu">Recording devices with evemu</a>. This is the most important piece of information, do not forget it!</li>
<li>the output from udevadm info, see <a class="el" href="reporting_bugs.html#udev_info">udev information for the device</a>.</li>
<li>the vendor model number of your laptop (e.g. "Lenovo Thinkpad T440s")</li>
<li>and the content of <code>/sys/class/dmi/id/modalias</code>.</li>
<li>run the <code>touchpad-edge-detectior</code> tool (provided by libevdev) and verify that the ranges and sizes it prints match the touchpad (up to 5mm difference is ok)</li>
</ul>
<p>If you are reporting a bug related to button event generation:</p>
<ul>
<li>does your touchpad have (separate) physical hardware buttons or is the whole touchpad clickable?</li>
<li>Are you using software buttons or clickfinger? See <a class="el" href="clickpad_softbuttons.html">Clickpad software button behavior</a>.</li>
<li>Do you have <a class="el" href="tapping.html">Tap-to-click behaviour</a> enabled?</li>
</ul>
<h1><a class="anchor" id="reporting_bugs_mouse"></a>
Reporting mouse bugs</h1>
<p>When you file a bug, please attach the following information:</p>
<ul>
<li>a virtual description of your input device, see <a class="el" href="reporting_bugs.html#evemu">Recording devices with evemu</a>. This is the most important piece of information, do not forget it!</li>
<li>the vendor model number of the device (e.g. "Logitech M325")</li>
<li>the output from udevadm info, see <a class="el" href="reporting_bugs.html#udev_info">udev information for the device</a>.</li>
</ul>
<p>If the bug is related to the <a class="el" href="motion_normalization.html#motion_normalization_customization">speed of the mouse</a>:</p>
<ul>
<li>the resolution of the mouse as specified by the vendor (in DPI)</li>
<li>the output of the <code>mouse-dpi-tool</code> (provided by libevdev)</li>
</ul>
<h1><a class="anchor" id="reporting_bugs_keyboard"></a>
Reporting keyboard bugs</h1>
<p>Is your bug related to a keyboard layout? libinput does not handle keyboard layouts and merely forwards the physical key events. File the bug with your desktop environment instead (e.g. GNOME, KDE, ...), that's most likely where the issue is.</p>
<p>When you file a bug, please attach the following information:</p>
<ul>
<li>a virtual description of your input device, see <a class="el" href="reporting_bugs.html#evemu">Recording devices with evemu</a>. This is the most important piece of information, do not forget it!</li>
</ul>
<h1><a class="anchor" id="reporting_bugs_trackpoint"></a>
Reporting trackpoint bugs</h1>
<p>When you file a bug, please attach the following information:</p>
<ul>
<li>a virtual description of your input device, see <a class="el" href="reporting_bugs.html#evemu">Recording devices with evemu</a>. This is the most important piece of information, do not forget it!</li>
<li>the vendor model number of the device (e.g. "Logitech M325")</li>
<li>the output from udevadm info, see <a class="el" href="reporting_bugs.html#udev_info">udev information for the device</a>.</li>
<li>the output of <code>libinput measure trackpoint-range</code></li>
<li>the sensitivity of the trackpoint (adjust the event node number as needed):</li>
</ul>
<pre class="fragment">$ cat /sys/class/input/event17/device/device/sensitivity
</pre><h1><a class="anchor" id="reporting_bugs_other"></a>
All other devices</h1>
<p>When you file a bug, please attach the following information:</p>
<ul>
<li>a virtual description of your input device, see <a class="el" href="reporting_bugs.html#evemu">Recording devices with evemu</a>. This is the most important piece of information, do not forget it!</li>
<li>the vendor model number of the device (e.g. "Sony Plastation3 controller")</li>
</ul>
<h1><a class="anchor" id="udev_info"></a>
udev information for the device</h1>
<p>In many cases, we require the udev properties assigned to the device to verify whether device-specific quirks were applied. This can be obtained with `<code>udevadm info /sys/class/input/eventX</code>, with the correct event node for your device. An example output is below:</p>
<div class="fragment"><div class="line">$ udevadm info /sys/<span class="keyword">class</span>/input/event4</div><div class="line">P: /devices/platform/i8042/serio1/input/input5/event4</div><div class="line">N: input/event4</div><div class="line">E: DEVNAME=/dev/input/event4</div><div class="line">E: DEVPATH=/devices/platform/i8042/serio1/input/input5/event4</div><div class="line">E: EVDEV_ABS_00=::41</div><div class="line">E: EVDEV_ABS_01=::37</div><div class="line">E: EVDEV_ABS_35=::41</div><div class="line">E: EVDEV_ABS_36=::37</div><div class="line">E: ID_INPUT=1</div><div class="line">E: ID_INPUT_HEIGHT_MM=66</div><div class="line">E: ID_INPUT_TOUCHPAD=1</div><div class="line">E: ID_INPUT_WIDTH_MM=97</div><div class="line">E: MAJOR=13</div><div class="line">E: MINOR=68</div><div class="line">E: SUBSYSTEM=input</div><div class="line">E: USEC_INITIALIZED=5463031</div></div><!-- fragment --><h1><a class="anchor" id="evemu"></a>
Recording devices with evemu</h1>
<dl class="section note"><dt>Note</dt><dd>Where available, the <a class="el" href="tools.html#libinput-record">libinput record and libinput replay</a> tools should be used instead of evemu</dd></dl>
<p><a href="https://www.freedesktop.org/wiki/Evemu/">evemu</a> records the device capabilities together with the event stream from the kernel. On our side, this allows us to recreate a virtual device identical to your device and re-play the event sequence, hopefully triggering the same bug.</p>
<p>evemu-record takes a <code>/dev/input/eventX</code> event node, but without arguments it will simply show the list of devices and let you select: </p><div class="fragment"><div class="line">$ sudo evemu-record &gt; scroll.evemu</div><div class="line">Available devices:</div><div class="line">/dev/input/event0:      Lid Switch</div><div class="line">/dev/input/event1:      Sleep Button</div><div class="line">/dev/input/event2:      Power Button</div><div class="line">/dev/input/event3:      AT Translated Set 2 keyboard</div><div class="line">/dev/input/event4:      SynPS/2 Synaptics TouchPad</div><div class="line">/dev/input/event5:      Video Bus</div><div class="line">/dev/input/event6:      ELAN Touchscreen</div><div class="line">/dev/input/event10:     ThinkPad Extra Buttons</div><div class="line">/dev/input/event11:     HDA Intel HDMI HDMI/DP,pcm=3</div><div class="line">/dev/input/event12:     HDA Intel HDMI HDMI/DP,pcm=7</div><div class="line">/dev/input/event13:     HDA Intel HDMI HDMI/DP,pcm=8</div><div class="line">/dev/input/event14:     HDA Intel PCH Dock Mic</div><div class="line">/dev/input/event15:     HDA Intel PCH Mic</div><div class="line">/dev/input/event16:     HDA Intel PCH Dock Headphone</div><div class="line">/dev/input/event17:     HDA Intel PCH Headphone</div><div class="line">/dev/input/event18:     Integrated Camera</div><div class="line">/dev/input/event19:     TPPS/2 IBM TrackPoint</div><div class="line">Select the device <span class="keyword">event</span> number [0-19]:</div></div><!-- fragment --><p>Select the device that triggers the issue, then reproduce the bug and Ctrl+C the process. The resulting recording, ("scroll.evemu" in this example) will contain the sequence required to reproduce the bug. If the bug fails to reproduce during recording, simply Ctrl+C and restart evemu-record. Always start the recording from a neutral state, i.e. without any buttons or keys down, with the position of the device in the neutral position, without touching the screen/touchpad.</p>
<dl class="section note"><dt>Note</dt><dd>The longer the recording, the harder it is to identify the event sequence triggering the bug. Please keep the event sequence as short as possible.</dd></dl>
<p>To verify that the recording contains the bug, you can replay it on your device. For example, to replay the sequence recorded in the example above: </p><div class="fragment"><div class="line">$ sudo evemu-play /dev/input/event4 &lt; scroll.evemu</div></div><!-- fragment --><p>If the bug is triggered by replaying on your device, attach the recording to the bug report.</p>
<dl class="section note"><dt>Note</dt><dd>libinput does not affect the evemu recording. libinput and evemu talk directly to the kernel's device nodes. An evemu recording is not influenced by the libinput version or whether a libinput context is currently active.</dd></dl>
<p><div class="dotgraph">
<img src="dot_evemu.png" alt="dot_evemu.png" border="0" usemap="#dot_evemu.map"/>
<map name="dot_evemu.map" id="dot_evemu.map"></map>
</div>
</p>
<h1><a class="anchor" id="fixed_bugs"></a>
My bug was closed as fixed, what now?</h1>
<p>libinput's policy on closing bugs is: once the fix for a given bug is on git master, the bug is considered fixed and the bugzilla entry will be closed accordingly.</p>
<p>Of course, unless you actually run git master, the bug will continue to affect you on your local machine. You are most likely running the distribution's package and you will need to wait until the distribution has updated its package accordingly.</p>
<p><b>Do not re-open a bug just because it hasn't trickled down to your distribution's package version yet.</b></p>
<p>Whether the bug fix ends up in your distribution depends on a number of things. Any given bug fix <b>may</b> be cherry-picked into the current stable branch, depending on its severity, impact, and likelyhood to cause regressions. Once cherry-picked it will land in the next stable branch release. These are usually a few weeks apart.</p>
<p><b>Do not re-open a bug because it wasn't picked into a stable branch release or because your distribution didn't update to the latest stable branch release.</b></p>
<p>Stable branches are usually discontinued when the next release comes out.</p>
<p>Your distribution may pick a patch up immediately and ship the fix even before the next stable branch update is released. For example, Fedora does this frequently.</p>
<p><b>If a bug needs to be fixed urgently, file a bug in your distribution's bug tracker.</b></p>
<p>Patches on git master will end up in the next libinput release. Once your distribution updates to that release, your local libinput version will contain the fix.</p>
<p><b>Do not re-open a bug because your distribution didn't update to the release.</b></p>
<p>You can always run libinput from git master (see <a class="el" href="building_libinput.html">libinput build instructions</a>). Even while in development, libinput is very stable so this option isn't as scary as it may sounds.</p>
<h2><a class="anchor" id="reporting_bugs_reopen"></a>
When is it ok to re-open a fixed bug?</h2>
<p>Any time the bug was considered fixed but it turns out that the fix is insufficient and/or causes a regression.</p>
<p>However, if the regression is in behavior unrelated to the fix itself it is usually better to file a new bug to reduce the noise. For example, if a fix to improve tapping breaks two-finger scrolling behavior, you should file a new bug but reference the original bug. </p>
</div></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.8-->
<!-- start footer part -->
</div>
</div>
</div>
</div>
</div>
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
